package com.example.scrollbardemo;

import com.vaadin.Application;
import com.vaadin.terminal.ThemeResource;
import com.vaadin.ui.HorizontalLayout;
import com.vaadin.ui.Label;
import com.vaadin.ui.Panel;
import com.vaadin.ui.TabSheet;
import com.vaadin.ui.TextField;
import com.vaadin.ui.VerticalLayout;
import com.vaadin.ui.Window;
import com.vaadin.ui.themes.Reindeer;

public class ScrollbardemoApplication extends Application {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Override
	public void init() {
		setTheme("scrollbar-theme");
		Window mainWindow = new Window("Scrollbardemo Application");
		TabSheet tabSheet = new TabSheet();

		// just to have more than one tab...
		final VerticalLayout barLayout = new VerticalLayout();
		barLayout.setHeight("450px");
		barLayout.addComponent(new Label("Hello Vaadin user!"));

		// here's the panel we're talking about
		final Panel fooPanel = new Panel();
		fooPanel.setWidth("100%");
		final Panel hPanel = new Panel();
		hPanel.setStyleName(Reindeer.PANEL_LIGHT);
		hPanel.setWidth("100%");
		/*
		 * set a fixed height, so that the horizontal scrollbar is always
		 * displayed (commenting the following line results on the h. scrollbar
		 * being concealed "under" the parent panel)
		 */
		hPanel.setHeight("200px");
		HorizontalLayout hLayout = new HorizontalLayout();
		// here's the text area that must contain up to 320 chars
		TextField longField = new TextField();
		// magic number to fit 320 chars with the font I've chosen
		longField.setColumns(188);
		longField.addStyleName("truetype");
		longField.setWordwrap(false);
		longField.setHeight("100%");
		longField.setInputPrompt("Here the user can write rows of fixed-length data"
				+ " and they should be able to visually compare fields on-the-fly\n"
				+ "That's why we have this odd-looking very long text area containing "
				+ "approximately up to 320 chars.\n"
				+ "Try adding some lines to see the text area's scrollbar appear at "
				+ "the right end of the page");

		hLayout.setHeight("100%");
		hLayout.addComponent(longField);

		hPanel.setContent(hLayout);
		hPanel.addStyleName("novscroll");
		hLayout.addStyleName("novscroll");

		fooPanel.addComponent(hPanel);
		fooPanel.addComponent(new Label("Here goes other stuff..."));

		tabSheet.addTab(fooPanel, "Foo", new ThemeResource("../runo/icons/16/globe.png"));
		tabSheet.addTab(barLayout, "Bar", new ThemeResource("../runo/icons/16/folder.png"));

		mainWindow.addComponent(tabSheet);
		setMainWindow(mainWindow);
	}

}
